﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Security;
using Syncfusion.Pdf.Graphics;
using System.IO;
using System.Diagnostics;
using System.Drawing;

namespace DigitalSignatureSample
{
    class Program
    {
        static void Main(string[] args)
        {
            //Loads a PDF document
            PdfLoadedDocument loadedDocument = new PdfLoadedDocument("../../Data/Barcode.pdf");

            //Load a page
            PdfPageBase page = loadedDocument.Pages[0] as PdfPageBase;
            PdfGraphics graphics = page.Graphics;

            //Creates a certificate instance from PFX file with private key
            PdfCertificate pdfCert = new PdfCertificate(@"../../Data/PDF.pfx", "syncfusion");

            //Creates a digital signature
            PdfSignature signature = new PdfSignature(loadedDocument, page, pdfCert, "Signature1");

            //Sets an image for signature field
            PdfBitmap signatureImage = new PdfBitmap(@"../../Data/logo.png");

            //Sets signature information
            signature.Bounds = new RectangleF(new PointF(0, 0), signatureImage.PhysicalDimension);
            signature.ContactInfo = "johndoe@owned.us";
            signature.LocationInfo = "Honolulu, Hawaii";
            signature.Reason = "I am author of this document.";

            //Draws the signature image
            graphics.DrawImage(signatureImage, 0, 0);

            //Saves and closes the document
            MemoryStream ms = new MemoryStream();
            loadedDocument.Save(ms);
            loadedDocument.Close(true);

            //Loads a PDF document
            PdfLoadedDocument loadedDocument1 = new PdfLoadedDocument(ms);

            //Load a page
            PdfPageBase pageBase = loadedDocument1.Pages[0] as PdfPageBase;

            //Creates a digital signature
            PdfSignature pdfSignature = new PdfSignature(loadedDocument1, pageBase, pdfCert, "Signature2");

            //Sets signature information
            pdfSignature.Bounds = new RectangleF(new PointF(40, 200), signatureImage.PhysicalDimension);
            pdfSignature.ContactInfo = "Henry@owned.us";
            pdfSignature.LocationInfo = "sasdfadf, asdasf";
            pdfSignature.Reason = "Syncfuion multiple signature demo";
            pdfSignature.EnableValidationAppearance = true;

            loadedDocument1.Save("Output.pdf");
            loadedDocument1.Close(true);

            Process.Start("Output.pdf");
        }
    }
}
